
#
# GENERATED WITH PDL::PP! Don't modify!
#
package PDL::Math;

@EXPORT_OK  = qw( acos asin atan cosh sinh tan tanh ceil floor rint pow acosh asinh atanh erf erfc bessj0 bessj1 bessy0 bessy1 bessjn bessyn lgamma badmask erfi ndtri svd eigens simq squaretotri );
%EXPORT_TAGS = (Func=>[@EXPORT_OK]);

use PDL::Core;
use PDL::Exporter;
use DynaLoader;



   
   @ISA    = ( 'PDL::Exporter','DynaLoader' );
   push @PDL::Core::PP, __PACKAGE__;
   bootstrap PDL::Math ;




=head1 NAME

PDL::Math - extended mathematical operations and special functions

=head1 SYNOPSIS

 use PDL::Math;

 use PDL::Graphics::TriD;
 imag3d [SURF2D,bessj0(rvals(zeroes(50,50))/2)];

=head1 DESCRIPTION

This module extends PDL with more advanced mathematical
functions than provided by standard Perl.

All the functions have one input pdl, and one output, unless otherwise
stated.

The functions are usually available from the system
maths library, however if they are not (determined
when PDL is compiled) a version from the Cephes math
library is used.

=cut






=head1 FUNCTIONS



=cut






=head2 acos

=for sig

  Signature: (a(); [o]b())

=for ref

The usual trigonometric function.

=cut




sub PDL::acos {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_acos_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_acos_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_acos_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for acos";
		}
		}

*acos = \&PDL::acos;




=head2 asin

=for sig

  Signature: (a(); [o]b())

=for ref

The usual trigonometric function.

=cut




sub PDL::asin {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_asin_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_asin_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_asin_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for asin";
		}
		}

*asin = \&PDL::asin;




=head2 atan

=for sig

  Signature: (a(); [o]b())

=for ref

The usual trigonometric function.

=cut




sub PDL::atan {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_atan_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_atan_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_atan_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for atan";
		}
		}

*atan = \&PDL::atan;




=head2 cosh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::cosh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_cosh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_cosh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_cosh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for cosh";
		}
		}

*cosh = \&PDL::cosh;




=head2 sinh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::sinh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_sinh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_sinh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_sinh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for sinh";
		}
		}

*sinh = \&PDL::sinh;




=head2 tan

=for sig

  Signature: (a(); [o]b())

=for ref

The usual trigonometric function.

=cut




sub PDL::tan {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_tan_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_tan_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_tan_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for tan";
		}
		}

*tan = \&PDL::tan;




=head2 tanh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::tanh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_tanh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_tanh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_tanh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for tanh";
		}
		}

*tanh = \&PDL::tanh;




=head2 ceil

=for sig

  Signature: (a(); [o]b())

=for ref

Round to integral values in floating-point format

=cut




sub PDL::ceil {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_ceil_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_ceil_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_ceil_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for ceil";
		}
		}

*ceil = \&PDL::ceil;




=head2 floor

=for sig

  Signature: (a(); [o]b())

=for ref

Round to integral values in floating-point format

=cut




sub PDL::floor {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_floor_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_floor_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_floor_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for floor";
		}
		}

*floor = \&PDL::floor;




=head2 rint

=for sig

  Signature: (a(); [o]b())

=for ref

Round to integral values in floating-point format

=cut




sub PDL::rint {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_rint_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_rint_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_rint_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for rint";
		}
		}

*rint = \&PDL::rint;




=head2 pow

=for sig

  Signature: (a(); b(); [o]c())

=for ref

Synonym for `**'

=cut




sub PDL::pow {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_pow_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_pow_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_pow_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for pow";
		}
		}

*pow = \&PDL::pow;




=head2 acosh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::acosh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_acosh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_acosh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_acosh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for acosh";
		}
		}

*acosh = \&PDL::acosh;




=head2 asinh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::asinh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_asinh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_asinh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_asinh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for asinh";
		}
		}

*asinh = \&PDL::asinh;




=head2 atanh

=for sig

  Signature: (a(); [o]b())

=for ref

The standard hyperbolic function.

=cut




sub PDL::atanh {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_atanh_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_atanh_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_atanh_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for atanh";
		}
		}

*atanh = \&PDL::atanh;




=head2 erf

=for sig

  Signature: (a(); [o]b())

=for ref

The error function

=cut




sub PDL::erf {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_erf_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_erf_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_erf_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for erf";
		}
		}

*erf = \&PDL::erf;




=head2 erfc

=for sig

  Signature: (a(); [o]b())

=for ref

The complement of the error function

=cut




sub PDL::erfc {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_erfc_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_erfc_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_erfc_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for erfc";
		}
		}

*erfc = \&PDL::erfc;




=head2 bessj0

=for sig

  Signature: (a(); [o]b())


=for ref

The standard Bessel Functions



=cut




sub PDL::bessj0 {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_bessj0_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_bessj0_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_bessj0_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessj0";
		}
		}

*bessj0 = \&PDL::bessj0;




=head2 bessj1

=for sig

  Signature: (a(); [o]b())


=for ref

The standard Bessel Functions



=cut




sub PDL::bessj1 {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_bessj1_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_bessj1_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_bessj1_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessj1";
		}
		}

*bessj1 = \&PDL::bessj1;




=head2 bessy0

=for sig

  Signature: (a(); [o]b())


=for ref

The standard Bessel Functions



=cut




sub PDL::bessy0 {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_bessy0_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_bessy0_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_bessy0_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessy0";
		}
		}

*bessy0 = \&PDL::bessy0;




=head2 bessy1

=for sig

  Signature: (a(); [o]b())


=for ref

The standard Bessel Functions



=cut




sub PDL::bessy1 {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_bessy1_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_bessy1_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_bessy1_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessy1";
		}
		}

*bessy1 = \&PDL::bessy1;




=head2 bessjn

=for sig

  Signature: (a(); int n(); [o]b())


=for ref

The standard Bessel Functions

=cut
=pod
This has a second integer
argument which gives the order of the function required.


=cut




sub PDL::bessjn {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_bessjn_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_bessjn_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_bessjn_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessjn";
		}
		}

*bessjn = \&PDL::bessjn;




=head2 bessyn

=for sig

  Signature: (a(); int n(); [o]b())


=for ref

The standard Bessel Functions

=cut
=pod
This has a second integer
argument which gives the order of the function required.


=cut




sub PDL::bessyn {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_bessyn_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_bessyn_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_bessyn_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for bessyn";
		}
		}

*bessyn = \&PDL::bessyn;




=head2 lgamma

=for sig

  Signature: (a(); [o]b(); int[o]s())

=for ref

log gamma function

This returns 2 piddles -- the first set gives the log(gamma) values,
while the second set, of integer values, gives the sign of the gamma
function.  This is useful for determining factorials, amongst other
things.



=cut




sub PDL::lgamma {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_lgamma_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_lgamma_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[2] = PDL->nullcreate($a[0]) );
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_lgamma_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for lgamma";
		}
		}

*lgamma = \&PDL::lgamma;




=head2 badmask

=for sig

  Signature: (a(); b(); [o]c())

=for ref

Clears all infs and nans in a to the corresponding value in b

=cut




sub PDL::badmask {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_badmask_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_badmask_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_badmask_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for badmask";
		}
		}

*badmask = \&PDL::badmask;




=head2 erfi

=for sig

  Signature: (a(); [o]b())

=for ref

The inverse of the error function

=cut




sub PDL::erfi {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_erfi_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_erfi_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_erfi_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for erfi";
		}
		}

*erfi = \&PDL::erfi;




=head2 ndtri

=for sig

  Signature: (a(); [o]b())

The value for which the area under the
Gaussian probability density function (integrated from
minus infinity) is equal to the argument (cf erfi)

=cut




sub PDL::ndtri {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_ndtri_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_ndtri_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_ndtri_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for ndtri";
		}
		}

*ndtri = \&PDL::ndtri;




=head2 svd

=for sig

  Signature: (a(n,m); [o]u(n,m); [o,phys]z(n); [o]v(n,n))


=for ref

Singular value decomposition of array.

=for usage

      ($u, $s, $v) = svd($a);



=cut




sub PDL::svd {
               my @a = @_;
               if($#a == 3 || $#a == -1 ) { &PDL::_svd_int; }
                elsif($#a == 3) {
		 	
                       &PDL::_svd_int(@a);@a=();
               } elsif($#a == 0) {
			my @ret;
			unshift @ret,($a[3] = PDL->nullcreate($a[0]) );
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_svd_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for svd";
		}
		}

*svd = \&PDL::svd;




=head2 eigens

=for sig

  Signature: ([phys]a(m); [o,phys]ev(n,n); [o,phys]e(n))


=for ref

Eigenvalues and -vectors of a symmetric square matrix.  If passed
an asymmetric matrix, the routine will warn and symmetrize it.

=for usage

      ($e, $ev) = eigens($a);



=cut





sub PDL::eigens {
      my ($a) = @_;
      my (@d) = $a->dims;
      barf "Need real square matrix for eigens" 
            if $#d != 1 or $d[0] != $d[1];
      my ($n) = $d[0];
      my ($sym) = 0.5*($a + $a->mv(0,1));
      my ($err) = PDL::max(abs($sym));
      barf "Need symmetric component non-zero for eigens"
          if $err == 0;
      $err = PDL::max(abs($a-$sym))/$err;
      warn "Using symmetrized version of the matrix in eigens"
          if $err > 1e-5;
      # Get lower triangular form -- 
      my ($lt) = PDL::where($sym,$sym->xvals <= $sym->yvals)->copy;
      my ($ev) = PDL->zeroes($n,$n);
      my ($e)  = PDL->zeroes($n);
      &PDL::_eigens_int($lt, $ev, $e);
      return $ev, $e;
}


*eigens = \&PDL::eigens;




=head2 simq

=for sig

  Signature: ([phys]a(n,n); [phys]b(n); [o,phys]x(n); int [o,phys]ips(n); int flag)


=for ref

Solution of simultaneous linear equations, a x = b.

a is an n x n matrix (i.e., a vector of length n*n), stored row-wise:
that is, a(i,j) = a[ij], where ij = i*n + j.  While this is the
transpose of the normal column-wise storage, this corresponds to
normal PDL usage.  The contents of matrix a may be altered (but may be
required for subsequent calls with flag = -1).

b, x, ips are vectors of length n.

Set flag=0 to solve.  Set flag=-1 to do a new back substitution for
different b vector using the same a matrix previously reduced when
flag=0 (the ips vector generated in the previous solution is also
required).



=cut




sub PDL::simq {
               my @a = @_;
               if($#a == 4 || $#a == -1 ) { &PDL::_simq_int; }
                elsif($#a == 4) {
		 	
                       &PDL::_simq_int(@a);@a=();
               } elsif($#a == 2) {
			my @ret;
			$a[4] = $a[2];
unshift @ret,($a[3] = PDL->nullcreate($a[0]) );
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_simq_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for simq";
		}
		}

*simq = \&PDL::simq;




=head2 squaretotri

=for sig

  Signature: (a(n,n); b(m))


=for ref

Convert a symmetric square matrix to triangular vector storage



=cut




sub PDL::squaretotri {
               my @a = @_;
               if($#a == 1 || $#a == -1 ) { &PDL::_squaretotri_int; }
                elsif($#a == 1) {
		 	
                       &PDL::_squaretotri_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			
                       &PDL::_squaretotri_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for squaretotri";
		}
		}

*squaretotri = \&PDL::squaretotri;


;


sub eigen_c {
	my($mat) = @_;
	my $s = $mat->getdim(0);
	my $z = zeroes($s * ($s+1) / 2);
	my $ev = zeroes($s);
	squaretotri($mat,$z);
	my $k = 0 * $mat;
	PDL::eigens($z, $k, $ev);
	return ($ev, $k);
}


=head1 BUGS

Hasn't been tested on all platforms to ensure Cephes
versions are picked up automatically and used correctly.

=head1 AUTHOR

Copyright (C) R.J.R. Williams 1997 (rjrw@ast.leeds.ac.uk), Karl Glazebrook
(kgb@aaoepp.aao.gov.au) and Tuomas J. Lukka (Tuomas.Lukka@helsinki.fi).

All rights reserved. There is no warranty. You are allowed
to redistribute this software / documentation under certain
conditions. For details, see the file COPYING in the PDL
distribution. If this file is separated from the PDL distribution,
the copyright notice should be included in the file.


=cut




# Exit with OK status

1;

