
#
# GENERATED WITH PDL::PP! Don't modify!
#
package PDL::Ops;

@EXPORT_OK  = qw( my_biop1 my_biop2 my_biop3 my_bifunc1 my_ufunc1 my_ufunc1f my_ufunc2 my_ufunc2f );
%EXPORT_TAGS = (Func=>[@EXPORT_OK]);

use PDL::Core;
use PDL::Exporter;
use DynaLoader;



   
   @ISA    = ( 'PDL::Exporter','DynaLoader' );
   push @PDL::Core::PP, __PACKAGE__;
   bootstrap PDL::Ops ;





=head1 NAME

PDL::Ops - Fundamental mathematical operators

=head1 DESCRIPTION

This module provides the functions used by PDL to
overload the basic mathematical operators (C<+ - / *>
etc.) and functions (C<sin sqrt> etc.)

You probably don't need to know about this
and the interface may well
change so the documentation ends here.

=head1 SYNOPSIS

none

=cut







=head1 FUNCTIONS



=cut






=head2 my_biop1

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop1 {
               my @a = @_;
               if($#a == 3 || $#a == -1 ) { &PDL::_my_biop1_int; }
                elsif($#a == 3) {
		 	
                       &PDL::_my_biop1_int(@a);@a=();
               } elsif($#a == 2) {
			my @ret;
			$a[3] = $a[2];
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_my_biop1_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop1";
		}
		}

*my_biop1 = \&PDL::my_biop1;




=head2 my_biop2

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop2 {
               my @a = @_;
               if($#a == 3 || $#a == -1 ) { &PDL::_my_biop2_int; }
                elsif($#a == 3) {
		 	
                       &PDL::_my_biop2_int(@a);@a=();
               } elsif($#a == 2) {
			my @ret;
			$a[3] = $a[2];
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_my_biop2_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop2";
		}
		}

*my_biop2 = \&PDL::my_biop2;




=head2 my_biop3

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_biop3 {
               my @a = @_;
               if($#a == 3 || $#a == -1 ) { &PDL::_my_biop3_int; }
                elsif($#a == 3) {
		 	
                       &PDL::_my_biop3_int(@a);@a=();
               } elsif($#a == 2) {
			my @ret;
			$a[3] = $a[2];
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_my_biop3_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_biop3";
		}
		}

*my_biop3 = \&PDL::my_biop3;




=head2 my_bifunc1

=for sig

  Signature: (a(); b(); [o]c(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_bifunc1 {
               my @a = @_;
               if($#a == 3 || $#a == -1 ) { &PDL::_my_bifunc1_int; }
                elsif($#a == 3) {
		 	
                       &PDL::_my_bifunc1_int(@a);@a=();
               } elsif($#a == 2) {
			my @ret;
			$a[3] = $a[2];
unshift @ret,($a[2] = PDL->nullcreate($a[0]) );

                       &PDL::_my_bifunc1_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_bifunc1";
		}
		}

*my_bifunc1 = \&PDL::my_bifunc1;




=head2 my_ufunc1

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc1 {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_my_ufunc1_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_my_ufunc1_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			$a[2] = $a[1];
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_my_ufunc1_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc1";
		}
		}

*my_ufunc1 = \&PDL::my_ufunc1;




=head2 my_ufunc1f

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc1f {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_my_ufunc1f_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_my_ufunc1f_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			$a[2] = $a[1];
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_my_ufunc1f_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc1f";
		}
		}

*my_ufunc1f = \&PDL::my_ufunc1f;




=head2 my_ufunc2

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc2 {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_my_ufunc2_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_my_ufunc2_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			$a[2] = $a[1];
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_my_ufunc2_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc2";
		}
		}

*my_ufunc2 = \&PDL::my_ufunc2;




=head2 my_ufunc2f

=for sig

  Signature: (a(); [o]b(); char* pdl_op)

=for ref

internal

=cut




sub PDL::my_ufunc2f {
               my @a = @_;
               if($#a == 2 || $#a == -1 ) { &PDL::_my_ufunc2f_int; }
                elsif($#a == 2) {
		 	
                       &PDL::_my_ufunc2f_int(@a);@a=();
               } elsif($#a == 1) {
			my @ret;
			$a[2] = $a[1];
unshift @ret,($a[1] = PDL->nullcreate($a[0]) );

                       &PDL::_my_ufunc2f_int(@a);@a=();
			return wantarray?(@ret):$ret[0];
		} else {
			barf "Invalid number of arguments for my_ufunc2f";
		}
		}

*my_ufunc2f = \&PDL::my_ufunc2f;


;


=head1 AUTHOR

Tuomas J. Lukka (lukka@fas.harvard.edu) and Karl Glazebrook
(kgb@aaoepp.aao.gov.au).

=cut





# Exit with OK status

1;

